package com.perforce.workshop.tjuricek.p4oauth

import org.gradle.api.Plugin
import org.gradle.api.Project

/**
 */
class P4OAuthPlugin implements Plugin<Project> {

    @Override
    void apply(Project project) {
        project.extensions.add("p4oauth", P4OAuthExtension)
        project.task('createKeystore', type: CreateKeystoreTask,
            description: "Create a test keystore file")
        project.task("startTestServer", type: StartTestServerTask,
            description: "Starts a test application that will authenticate")
        project.task("stopTestServer", type: StopTestServerTask,
            description: "Halts the test application server")
        project.task('startP4OAuth', type: StartP4OAuthTask,
            description: "Start the p4oauth server")
        project.task('stopP4OAuth', type: StopP4OAuthTask,
            description: "Stop the p4oauth server")

        project.tasks.startTestServer.dependsOn(":test_server:assemble", "createKeystore")

        project.tasks.startP4OAuth.dependsOn("startPerforce", "createKeystore", "startTestServer")
    }
}
